/* Note from nottud to other scripters - the input for functions like sin and cos
need to be converted from degrees into radians first before they will work
properly.

Use the command: rmDegreesToRadians(<degree input>);

I learnt the hard way :(.  I also thank Wolfenhex for making the following functions available for public use */

float PI = 3.141592;

float pow(float n = 0,int x = 0) {
	float r = n;
	for(i = 1; < x) {
		r = r * n;
	}
	return (r);
}

float atan(float n = 0) {
	float m = n;
	if(n > 1) m = 1.0 / n;
	if(n < -1) m = -1.0 / n;
	float r = m;
	for(i = 1; < 100) {
		int j = i * 2 + 1;
		float k = pow(m,j) / j;
		if(k == 0) break;
		if(i % 2 == 0) r = r + k;
		if(i % 2 == 1) r = r - k;
	}
	if(n > 1 || n < -1) r = PI / 2.0 - r;
	if(n < -1) r = 0.0 - r;
	return (r);
}

float atan2(float z = 0,float x = 0) {
	if(x > 0) return (atan(z / x));
	if(x < 0) {
		if(z < 0) return (atan(z / x) - PI);
		if(z > 0) return (atan(z / x) + PI);
		return (PI);
	}
	if(z > 0) return (PI / 2.0);
	if(z < 0) return (0.0 - (PI / 2.0));
	return (0);
}

float fact(float n = 0) {
	float r = 1;
	for(i = 1; <= n) {
		r = r * i;
	}
	return (r);
}

float cos(float n = 0) {
	float r = 1;
	for(i = 1; < 100) {
		int j = i * 2;
		float k = pow(n,j) / fact(j);
		if(k == 0) break;
		if(i % 2 == 0) r = r + k;
		if(i % 2 == 1) r = r - k;
	}
	return (r);
}

float sin(float n = 0) {
	float r = n;
	for(i = 1; < 100) {
		int j = i * 2 + 1;
		float k = pow(n,j) / fact(j);
		if(k == 0) break;
		if(i % 2 == 0) r = r + k;
		if(i % 2 == 1) r = r - k;
	}
	return (r);
}

// Circle placement stuff by Nottud

float circlex(float locationx = 0.0, int totalnumber = 0, int currentnumber = 0, float radius = 0.0, int displacement = 0){
	float a = ((360.0/totalnumber * (currentnumber-1)) + displacement + 45) % 360.0;
	float i = rmDegreesToRadians(a);
	float k = (((sin(i)*radius*2+1)/2)-0.5)+locationx;
	return(k);
}

float circley(float locationy = 0.0, int totalnumber = 0, int currentnumber = 0, float radius = 0.0, int displacement = 0){
	float a = ((360.0/totalnumber * (currentnumber-1)) + displacement + 45) % 360.0;
	float i = rmDegreesToRadians(a);
	float k = (((cos(i)*radius*2+1)/2)-0.5)+locationy;
	return(k);
}

float getCircleRot(int totalnumber = 0, int currentnumber = 0, int displacement = 0){
	float a = ((360.0/totalnumber * (currentnumber-1)) + displacement + 45) % 360.0;
	return(a);
}

// Custom trigger creator - By Nottud with a little help from Twenty One Score's bloodsport script

void code(string xs="") {
	rmAddTriggerEffect("SetIdleProcessing");
	rmSetTriggerEffectParam("IdleProc",");"+xs+"//");
}

void codedebug(string xs2="") {
	rmAddTriggerEffect("Send Chat To Player");
	rmSetTriggerEffectParamInt("PlayerID", 0);
	rmSetTriggerEffectParamInt("ToPlayerID", 0);
	rmSetTriggerEffectParam("Message","\");/**/"+xs2+"/**///");
}

void con(string xs3="") {
	rmAddTriggerCondition("Player Defeated");
	rmSetTriggerConditionParam("PlayerID","0)||("+xs3+"));//");
}

// Other

void randomlight() {
	code("trQuestVarSetFromRand(\"1R\", 0, 255, false);");
	code("trQuestVarSetFromRand(\"1G\", 0, 255, false);");
	code("trQuestVarSetFromRand(\"1B\", 0, 255, false);");
	code("trQuestVarSetFromRand(\"2R\", 0, 255, false);");
	code("trQuestVarSetFromRand(\"2G\", 0, 255, false);");
	code("trQuestVarSetFromRand(\"2B\", 0, 255, false);");
	code("trQuestVarSetFromRand(\"3R\", 0, 255, false);");
	code("trQuestVarSetFromRand(\"3G\", 0, 255, false);");
	code("trQuestVarSetFromRand(\"3B\", 0, 255, false);");
	code("trQuestVarSetFromRand(\"4R\", 0, 255, false);");
	code("trQuestVarSetFromRand(\"4G\", 0, 255, false);");
	code("trQuestVarSetFromRand(\"4B\", 0, 255, false);");
	code("fakeSpecularSunColor(trQuestVarGet(\"1R\"),trQuestVarGet(\"1G\"),trQuestVarGet(\"1B\"));");
	code("terrainAmbient(trQuestVarGet(\"2R\"),trQuestVarGet(\"2G\"),trQuestVarGet(\"2B\"));");
	code("sunColor(trQuestVarGet(\"3R\"),trQuestVarGet(\"3G\"),trQuestVarGet(\"3B\"));");
	code("ambientColor(trQuestVarGet(\"4R\"),trQuestVarGet(\"4G\"),trQuestVarGet(\"4B\"));");
}

void advancedLighting(int w1 = 0,int w2 = 0,int w3 = 0,int s1 = 0,int s2 = 0,int s3 = 0,int a1 = 0,int a2 = 0,int a3 = 0,int t1 = 0,int t2 = 0,int t3 = 0){
	code("fakeSpecularSunColor("+w1+","+w2+","+w3+");");
	code("sunColor("+s1+","+s2+","+s3+");");
	code("ambientColor("+a1+","+a2+","+a3+");");
	code("terrainAmbient("+t1+","+t2+","+t3+");");
}

void lightingRotation(int inc = 0,int rot = 0){
	code("subModeEnter(\"Simulation\", \"Editor\");");
	code("uiMessageBox(\"moo\",\"setSunPosition("+inc+","+rot+",false)\");");
	code("uiCycleCurrentActivate();");
	code("subModeLeave(\"Simulation\", \"Editor\");");
	code("modeEnter(\"pregame\");");
	code("modeEnter(\"Simulation\");");
	code("subModeEnter(\"Simulation\", \"Singleplayer\");");
}

void trCameraCut(string v1 = "(0,0,0)", string v2 = "(0,0,0)", string v3 = "(0,0,0)", string v4 = "(0,0,0)"){
	code("trCameraCut(vector" + v1 + ",/* ");
	code("*/vector" + v2 + ",/* ");
	code("*/vector" + v3 + ",/* ");
	code("*/vector" + v4 + ");");
}

void modifyProtounitAbsolute(string protounit = "", int p = 0, int field = 0, float value = 0.0){
	code("if("+field+" == 6){");
	code("trModifyProtounit(\""+protounit+"\", "+p+", "+field+", -9999999999999999999.0);");
	code("trModifyProtounit(\""+protounit+"\", "+p+", "+field+", "+value+" - 1);");
	code("} else if("+field+" == 5 || "+field+" == 7 || "+field+" == 10 || "+field+" == 13){");
	code("trModifyProtounit(\""+protounit+"\", "+p+", "+field+", 2147483648.0);");
	code("trModifyProtounit(\""+protounit+"\", "+p+", "+field+", 2147483648.0);");
	code("trModifyProtounit(\""+protounit+"\", "+p+", "+field+", "+value+");");
	code("} else {");
	code("trModifyProtounit(\""+protounit+"\", "+p+", "+field+", 9999999999999999999.0);");
	code("trModifyProtounit(\""+protounit+"\", "+p+", "+field+", -9999999999999999999.0);");
	code("trModifyProtounit(\""+protounit+"\", "+p+", "+field+", "+value+");");
	code("}");
}

int playerColor(int p = 0, int t = 1){
	int c = 0;
	if((p == 0)&&(t == 1))c = 153;
	if((p == 0)&&(t == 2))c = 102;
	if((p == 0)&&(t == 3))c = 0;
	if((p == 1)&&(t == 1))c = 50;
	if((p == 1)&&(t == 2))c = 50;
	if((p == 1)&&(t == 3))c = 255;
	if((p == 2)&&(t == 1))c = 255;
	if((p == 2)&&(t == 2))c = 50;
	if((p == 2)&&(t == 3))c = 50;
	if((p == 3)&&(t == 1))c = 0;
	if((p == 3)&&(t == 2))c = 150;
	if((p == 3)&&(t == 3))c = 0;
	if((p == 4)&&(t == 1))c = 50;
	if((p == 4)&&(t == 2))c = 235;
	if((p == 4)&&(t == 3))c = 255;
	if((p == 5)&&(t == 1))c = 223;
	if((p == 5)&&(t == 2))c = 52;
	if((p == 5)&&(t == 3))c = 238;
	if((p == 6)&&(t == 1))c = 255;
	if((p == 6)&&(t == 2))c = 255;
	if((p == 6)&&(t == 3))c = 0;
	if((p == 7)&&(t == 1))c = 255;
	if((p == 7)&&(t == 2))c = 102;
	if((p == 7)&&(t == 3))c = 0;
	if((p == 8)&&(t == 1))c = 128;
	if((p == 8)&&(t == 2))c = 0;
	if((p == 8)&&(t == 3))c = 64;
	if((p == 9)&&(t == 1))c = 50;
	if((p == 9)&&(t == 2))c = 255;
	if((p == 9)&&(t == 3))c = 50;
	if((p == 10)&&(t == 1))c = 179;
	if((p == 10)&&(t == 2))c = 251;
	if((p == 10)&&(t == 3))c = 186;
	if((p == 11)&&(t == 1))c = 80;
	if((p == 11)&&(t == 2))c = 80;
	if((p == 11)&&(t == 3))c = 80;
	if((p == 12)&&(t == 1))c = 255;
	if((p == 12)&&(t == 2))c = 0;
	if((p == 12)&&(t == 3))c = 102;
	return(c);
}

// Levels

int levels = 12;

int level1Size = 12;
string level1(int index = 0){
	if(index == 0)return ("Hoplite");
	if(index == 1)return ("Toxotes");
	if(index == 2)return ("Hippikon");
	if(index == 3)return ("Spearman");
	if(index == 4)return ("Axeman");
	if(index == 5)return ("Slinger");
	if(index == 6)return ("Ulfsark");
	if(index == 7)return ("Throwing Axeman");
	if(index == 8)return ("Raiding Cavalry");
	if(index == 9)return ("Swordsman");
	if(index == 10)return ("Maceman");
	if(index == 11)return ("Chieroballista");
}

int level2Size = 8;
string level2(int index = 0){
	if(index == 0)return ("Hypaspist");
	if(index == 1)return ("Peltast");
	if(index == 2)return ("Prodromos");
	if(index == 3)return ("Huskarl");
	if(index == 4)return ("Jarl");
	if(index == 5)return ("Archer Atlantean");
	if(index == 6)return ("Lancer");
	if(index == 7)return ("Trident Soldier");
}

int level3Size = 7;
string level3(int index = 0){
	if(index == 0)return ("Myrmidon");
	if(index == 1)return ("Hetairoi");
	if(index == 2)return ("Crossbowman");
	if(index == 3)return ("Chariot Archer");
	if(index == 4)return ("Camelry");
	if(index == 5)return ("War Elephant");
	if(index == 6)return ("Royal Guard");
}

int level4Size = 11;
string level4(int index = 0){
	if(index == 0)return ("Cyclops");
	if(index == 1)return ("Minotaur");
	if(index == 2)return ("Centaur");
	if(index == 3)return ("Anubite");
	if(index == 4)return ("Sphinx");
	if(index == 5)return ("Wadjet");
	if(index == 6)return ("Troll");
	if(index == 7)return ("Valkyrie");
	if(index == 8)return ("Einheriar");
	if(index == 9)return ("Promethean");
	if(index == 10)return ("Automaton");
}

int level5Size = 10;
string level5(int index = 0){
	if(index == 0)return ("Nemean Lion");
	if(index == 1)return ("Manticore");
	if(index == 2)return ("Hydra");
	if(index == 3)return ("Scarab");
	if(index == 4)return ("Scorpion Man");
	if(index == 5)return ("Petsuchos");
	if(index == 6)return ("Mountain Giant");
	if(index == 7)return ("Battle Boar");
	if(index == 8)return ("Behemoth");
	if(index == 9)return ("Satyr");
}

int level6Size = 9;
string level6(int index = 0){
	if(index == 0)return ("Colossus");
	if(index == 1)return ("Chimera");
	if(index == 2)return ("Avenger");
	if(index == 3)return ("Mummy");
	if(index == 4)return ("Fire Giant");
	if(index == 5)return ("Fenris Wolf");
	if(index == 6)return ("Lampades");
	if(index == 7)return ("Heka Gigantes");
	if(index == 8)return ("Argus");
}

int level7Size = 8;
string level7(int index = 0){
	if(index == 0)return ("Hero Greek Ajax");
	if(index == 1)return ("Hero Greek Jason");
	if(index == 2)return ("Hero Greek Theseus");
	if(index == 3)return ("Priest");
	if(index == 4)return ("Hero Norse");
	if(index == 5)return ("Swordsman Hero");
	if(index == 6)return ("Maceman Hero");
	if(index == 7)return ("Lancer Hero");
}

int level8Size = 5;
string level8(int index = 0){
	if(index == 0)return ("Hero Greek Odysseus");
	if(index == 1)return ("Hero Greek Hippolyta");
	if(index == 2)return ("Hero Greek Chiron");
	if(index == 3)return ("Pharaoh");
	if(index == 4)return ("Hero Ragnorok");
}

int level9Size = 5;
string level9(int index = 0){
	if(index == 0)return ("Hero Greek Heracles");
	if(index == 1)return ("Hero Greek Atalanta");
	if(index == 2)return ("Hero Greek Achilles");
	if(index == 3)return ("Hero Greek Bellerophon");
	if(index == 4)return ("Hero Greek Polyphemus");
}

int level10Size = 6;
string level10(int index = 0){
	if(index == 0)return ("Circe");
	if(index == 1)return ("Pharaoh of Osiris");
	if(index == 2)return ("Forkboy");
	if(index == 3)return ("Theris");
	if(index == 4)return ("Bella");
	if(index == 5)return ("Kronny");
}

int level11Size = 9;
string level11(int index = 0){
	if(index == 0)return ("Lazer bear");
	if(index == 1)return ("Titan Atlantean");
	if(index == 2)return ("Titan Bad");
	if(index == 3)return ("Titan Gaia");
	if(index == 4)return ("Titan Kronos");
	if(index == 5)return ("Guardian");
	if(index == 7)return ("Titan Prometheus");
	if(index == 8)return ("Osiris");
	if(index == 9)return ("Arkantos God");
}

int level12Size = 4;
string level12(int index = 0){
	if(index == 0)return ("Fortress");
	if(index == 1)return ("Palace");
	if(index == 2)return ("Migdol Stronghold");
	if(index == 3)return ("Hill Fort");
}

//Allow random drawing from a pool of up to 12 values without duplicate

int array0 = 0;
int array1 = 0;
int array2 = 0;
int array3 = 0;
int array4 = 0;
int array5 = 0;
int array6 = 0;
int array7 = 0;
int array8 = 0;
int array9 = 0;
int array10 = 0;
int array11 = 0;
int array12 = 0;
int array13 = 0;
int arraySize = 0;

int randomArrayGet(int index = 0){
	if(index == 0)return (array0);
	if(index == 1)return (array1);
	if(index == 2)return (array2);
	if(index == 3)return (array3);
	if(index == 4)return (array4);
	if(index == 5)return (array5);
	if(index == 6)return (array6);
	if(index == 7)return (array7);
	if(index == 8)return (array8);
	if(index == 9)return (array9);
	if(index == 10)return (array10);
	if(index == 11)return (array11);
	if(index == 12)return (array12);
	if(index == 13)return (array13);
}

void randomArraySet(int index = 0, int value = 0){
	if(index == 0)array0 = value;
	if(index == 1)array1 = value;
	if(index == 2)array2 = value;
	if(index == 3)array3 = value;
	if(index == 4)array4 = value;
	if(index == 5)array5 = value;
	if(index == 6)array6 = value;
	if(index == 7)array7 = value;
	if(index == 8)array8 = value;
	if(index == 9)array9 = value;
	if(index == 10)array10 = value;
	if(index == 11)array11 = value;
	if(index == 12)array12 = value;
	if(index == 13)array13 = value;
}

void randomArrayInitialise(int count = 0){
	for(i = 0; < count){
		randomArraySet(i, i);
	}
	arraySize = count;
}

int randomArrayNext(){
	int nextIndex = rmRandInt(0, arraySize - 1);
	int nextValue = randomArrayGet(nextIndex);
	randomArraySet(nextIndex, randomArrayGet(arraySize - 1));
	arraySize = arraySize - 1;
	return (nextValue);
}

//Chosen units

string level1Unit0 = "";
string level1Unit1 = "";
string level1Unit2 = "";
string level1Unit3 = "";

string level2Unit0 = "";
string level2Unit1 = "";
string level2Unit2 = "";
string level2Unit3 = "";

string level3Unit0 = "";
string level3Unit1 = "";
string level3Unit2 = "";
string level3Unit3 = "";

string level4Unit0 = "";
string level4Unit1 = "";
string level4Unit2 = "";
string level4Unit3 = "";

string level5Unit0 = "";
string level5Unit1 = "";
string level5Unit2 = "";
string level5Unit3 = "";

string level6Unit0 = "";
string level6Unit1 = "";
string level6Unit2 = "";
string level6Unit3 = "";

string level7Unit0 = "";
string level7Unit1 = "";
string level7Unit2 = "";
string level7Unit3 = "";

string level8Unit0 = "";
string level8Unit1 = "";
string level8Unit2 = "";
string level8Unit3 = "";

string level9Unit0 = "";
string level9Unit1 = "";
string level9Unit2 = "";
string level9Unit3 = "";

string level10Unit0 = "";
string level10Unit1 = "";
string level10Unit2 = "";
string level10Unit3 = "";

string level11Unit0 = "";
string level11Unit1 = "";
string level11Unit2 = "";
string level11Unit3 = "";

string level12Unit0 = "";
string level12Unit1 = "";
string level12Unit2 = "";
string level12Unit3 = "";

string getUnit(int level = 1, int unit = 0){
	if((level == 1) && (unit == 0))return (level1Unit0);
	if((level == 1) && (unit == 1))return (level1Unit1);
	if((level == 1) && (unit == 2))return (level1Unit2);
	if((level == 1) && (unit == 3))return (level1Unit3);
	if((level == 2) && (unit == 0))return (level2Unit0);
	if((level == 2) && (unit == 1))return (level2Unit1);
	if((level == 2) && (unit == 2))return (level2Unit2);
	if((level == 2) && (unit == 3))return (level2Unit3);
	if((level == 3) && (unit == 0))return (level3Unit0);
	if((level == 3) && (unit == 1))return (level3Unit1);
	if((level == 3) && (unit == 2))return (level3Unit2);
	if((level == 3) && (unit == 3))return (level3Unit3);
	if((level == 4) && (unit == 0))return (level4Unit0);
	if((level == 4) && (unit == 1))return (level4Unit1);
	if((level == 4) && (unit == 2))return (level4Unit2);
	if((level == 4) && (unit == 3))return (level4Unit3);
	if((level == 5) && (unit == 0))return (level5Unit0);
	if((level == 5) && (unit == 1))return (level5Unit1);
	if((level == 5) && (unit == 2))return (level5Unit2);
	if((level == 5) && (unit == 3))return (level5Unit3);
	if((level == 6) && (unit == 0))return (level6Unit0);
	if((level == 6) && (unit == 1))return (level6Unit1);
	if((level == 6) && (unit == 2))return (level6Unit2);
	if((level == 6) && (unit == 3))return (level6Unit3);
	if((level == 7) && (unit == 0))return (level7Unit0);
	if((level == 7) && (unit == 1))return (level7Unit1);
	if((level == 7) && (unit == 2))return (level7Unit2);
	if((level == 7) && (unit == 3))return (level7Unit3);
	if((level == 8) && (unit == 0))return (level8Unit0);
	if((level == 8) && (unit == 1))return (level8Unit1);
	if((level == 8) && (unit == 2))return (level8Unit2);
	if((level == 8) && (unit == 3))return (level8Unit3);
	if((level == 9) && (unit == 0))return (level9Unit0);
	if((level == 9) && (unit == 1))return (level9Unit1);
	if((level == 9) && (unit == 2))return (level9Unit2);
	if((level == 9) && (unit == 3))return (level9Unit3);
	if((level == 10) && (unit == 0))return (level10Unit0);
	if((level == 10) && (unit == 1))return (level10Unit1);
	if((level == 10) && (unit == 2))return (level10Unit2);
	if((level == 10) && (unit == 3))return (level10Unit3);
	if((level == 11) && (unit == 0))return (level11Unit0);
	if((level == 11) && (unit == 1))return (level11Unit1);
	if((level == 11) && (unit == 2))return (level11Unit2);
	if((level == 11) && (unit == 3))return (level11Unit3);
	if((level == 12) && (unit == 0))return (level12Unit0);
	if((level == 12) && (unit == 1))return (level12Unit1);
	if((level == 12) && (unit == 2))return (level12Unit2);
	if((level == 12) && (unit == 3))return (level12Unit3);
}

//Chosen Powers

int powers = 13;
string powerName(int index = 0){
	if(index == 0)return ("Animal Magnetism");
	if(index == 1)return ("Eclipse");
	if(index == 2)return ("Bronze");
	if(index == 3)return ("Bolt");
	if(index == 4)return ("Frost");
	if(index == 5)return ("Implode");
	if(index == 6)return ("Lightning Storm");
	if(index == 7)return ("Meteor");
	if(index == 8)return ("Vortex");
	if(index == 9)return ("Restoration");
	if(index == 10)return ("Tornado");
	if(index == 11)return ("Nidhogg");
	if(index == 12)return ("Audrey");
}

string powerDescription(int index = 0){
	if(index == 0)return ("Instant tower");
	if(index == 1)return ("Eclipse");
	if(index == 2)return ("Bronze");
	if(index == 3)return ("Super shockwave bolt");
	if(index == 4)return ("Instant kill frost");
	if(index == 5)return ("Implode");
	if(index == 6)return ("Lightning Storm");
	if(index == 7)return ("Meteor");
	if(index == 8)return ("Vortex");
	if(index == 9)return ("Restoration");
	if(index == 10)return ("Tornado");
	if(index == 11)return ("Instant son of osiris");
	if(index == 12)return ("Flaming Weapons");
}

int powerCost1 = 25;
int powerCost2 = 50;
int powerCost3 = 75;
int powerCost4 = 100;
int powerCost5 = 200;

int powerCost(int index = 0){
	if(index == 0)return (powerCost1);
	if(index == 1)return (powerCost2);
	if(index == 2)return (powerCost2);
	if(index == 3)return (powerCost3);
	if(index == 4)return (powerCost5);
	if(index == 5)return (powerCost4);
	if(index == 6)return (powerCost4);
	if(index == 7)return (powerCost4);
	if(index == 8)return (powerCost4);
	if(index == 9)return (powerCost2);
	if(index == 10)return (powerCost3);
	if(index == 11)return (powerCost3);
	if(index == 12)return (powerCost3);
}

int power0 = 0;
int power1 = 0;
int power2 = 0;
int power3 = 0;

int getPower(int index = 0){
	if(index == 0)return (power0);
	if(index == 1)return (power1);
	if(index == 2)return (power2);
	if(index == 3)return (power3);
}

// Main entry point for random map script
void main(void) {
	
	//Terrain constants
	int theme = rmRandInt(0, 2);
	
	string water = "South Sea";
	string terrain = "GrassB";
	string terrainMiddle = "GaiaCreepA";
	string tree = "Pine";
	if(theme == 1){
		water = "North Atlantic Ocean";
		terrain = "SnowB";
		terrainMiddle = "GaiaCreepASnow";
		tree = "Pine Snow";
	} else if(theme == 2){
		water = "Red Sea";
		terrain = "SandC";
		terrainMiddle = "GaiaCreepASand";
		tree = "Palm";
	}
	
	randomArrayInitialise(level1Size);
	level1Unit0 = level1(randomArrayNext());
	level1Unit1 = level1(randomArrayNext());
	level1Unit2 = level1(randomArrayNext());
	level1Unit3 = level1(randomArrayNext());
	
	randomArrayInitialise(level2Size);
	level2Unit0 = level2(randomArrayNext());
	level2Unit1 = level2(randomArrayNext());
	level2Unit2 = level2(randomArrayNext());
	level2Unit3 = level2(randomArrayNext());
	
	randomArrayInitialise(level3Size);
	level3Unit0 = level3(randomArrayNext());
	level3Unit1 = level3(randomArrayNext());
	level3Unit2 = level3(randomArrayNext());
	level3Unit3 = level3(randomArrayNext());
	
	randomArrayInitialise(level4Size);
	level4Unit0 = level4(randomArrayNext());
	level4Unit1 = level4(randomArrayNext());
	level4Unit2 = level4(randomArrayNext());
	level4Unit3 = level4(randomArrayNext());
	
	randomArrayInitialise(level5Size);
	level5Unit0 = level5(randomArrayNext());
	level5Unit1 = level5(randomArrayNext());
	level5Unit2 = level5(randomArrayNext());
	level5Unit3 = level5(randomArrayNext());
	
	randomArrayInitialise(level6Size);
	level6Unit0 = level6(randomArrayNext());
	level6Unit1 = level6(randomArrayNext());
	level6Unit2 = level6(randomArrayNext());
	level6Unit3 = level6(randomArrayNext());
	
	randomArrayInitialise(level7Size);
	level7Unit0 = level7(randomArrayNext());
	level7Unit1 = level7(randomArrayNext());
	level7Unit2 = level7(randomArrayNext());
	level7Unit3 = level7(randomArrayNext());
	
	randomArrayInitialise(level8Size);
	level8Unit0 = level8(randomArrayNext());
	level8Unit1 = level8(randomArrayNext());
	level8Unit2 = level8(randomArrayNext());
	level8Unit3 = level8(randomArrayNext());
	
	randomArrayInitialise(level9Size);
	level9Unit0 = level9(randomArrayNext());
	level9Unit1 = level9(randomArrayNext());
	level9Unit2 = level9(randomArrayNext());
	level9Unit3 = level9(randomArrayNext());
	
	randomArrayInitialise(level10Size);
	level10Unit0 = level10(randomArrayNext());
	level10Unit1 = level10(randomArrayNext());
	level10Unit2 = level10(randomArrayNext());
	level10Unit3 = level10(randomArrayNext());
	
	randomArrayInitialise(level11Size);
	level11Unit0 = level11(randomArrayNext());
	level11Unit1 = level11(randomArrayNext());
	level11Unit2 = level11(randomArrayNext());
	level11Unit3 = level11(randomArrayNext());	
	
	randomArrayInitialise(level12Size);
	level12Unit0 = level12(randomArrayNext());
	level12Unit1 = level12(randomArrayNext());
	level12Unit2 = level12(randomArrayNext());
	level12Unit3 = level12(randomArrayNext());
	
	randomArrayInitialise(powers);
	power0 = randomArrayNext();
	power1 = randomArrayNext();
	power2 = randomArrayNext();
	power3 = randomArrayNext();
	
	int c = cNumberNonGaiaPlayers;
	int id = 0;
	
	rmSetStatusText("",0.01);
	int mapSize = 500;
	if (cMapSize == 1) {
		mapSize = 750;
	} else if (cMapSize == 2) {
		mapSize = 1000;
	}
	mapSize = mapSize * 3 / 4 + mapSize * c / 32;
	rmSetMapSize(mapSize, mapSize);
	rmSetSeaLevel(0);
	rmSetSeaType("greek river");
	rmTerrainInitialize("grassB",1);
	rmSetGaiaCiv(cCivZeus);
	rmSetLightingSet("Default");
	
	id = rmCreateArea("a1a");
	rmSetAreaWaterType(id,water);
	rmSetAreaBaseHeight(id,3);
	rmSetAreaCoherence(id,1.0);
	rmSetAreaHeightBlend(id,1);
	rmSetAreaLocation(id,0.5,0.5);
	rmSetAreaSize(id,1,1);
	rmSetAreaSmoothDistance(id,5);
	rmBuildArea(id);

	for(i = 1; <= c) {
		id = rmCreateArea("playerareaA"+i);
		rmSetAreaCoherence(id,1.0);
		rmSetAreaLocation(id,circlex(0.5, c, i, 0.3, 0), circley(0.5, c, i, 0.3, 0));
		rmSetPlayerArea(i,id);
		rmSetAreaTerrainType(id,terrain);
		rmSetAreaBaseHeight(id,5);
		rmSetAreaHeightBlend(id,2);
		rmSetAreaSize(id,0.02,0.02);
	}
	
	for(i = 1; <= c) {
		id = rmCreateArea("playerareaB"+i);
		rmSetAreaCoherence(id,1.0);
		rmSetAreaLocation(id,circlex(0.5, c, i, 0.15, 360 / (c * 2)), circley(0.5, c, i, 0.15, 360 / (c * 2)));
		rmSetPlayerArea(i,id);
		rmSetAreaTerrainType(id,terrain);
		rmSetAreaBaseHeight(id,5);
		rmSetAreaHeightBlend(id,2);
		rmSetAreaSize(id,0.005,0.005);
	}
	
	id = rmCreateConnection("pathBetweenBasesA");
	rmSetConnectionType(id, cConnectAreas, false, 100);
	rmSetConnectionHeightBlend(id, 2);
	rmSetConnectionBaseHeight(id, 5);
	rmSetConnectionWidth(id, rmXFractionToMeters(0.03), 0);
	rmSetConnectionCoherence(id, 1.0);
	for(i = 1; <= c) {
		rmAddConnectionArea(id,rmAreaID("playerareaA"+i));
		rmAddConnectionArea(id,rmAreaID("playerareaB"+i));
	}
	rmBuildConnection(id);
	
	id = rmCreateArea("middle");
	rmSetAreaTerrainType(id,terrain);
	rmSetAreaBaseHeight(id,5);
	rmSetAreaCoherence(id,1.0);
	rmSetAreaHeightBlend(id,2);
	rmSetAreaLocation(id,0.5,0.5);
	rmSetAreaSize(id,0.01,0.01);
	rmSetAreaSmoothDistance(id,5);
	
	for(i = 1; <= c) {
		id = rmCreateConnection("pathBetweenBasesB"+i);
		rmSetConnectionType(id, cConnectAreas, false, 100);
		rmSetConnectionHeightBlend(id, 2);
		rmSetConnectionBaseHeight(id, 5);
		rmSetConnectionWidth(id, rmXFractionToMeters(0.03), 0);
		rmSetConnectionCoherence(id, 1.0);
		rmAddConnectionArea(id,rmAreaID("playerareaB"+i));
		rmAddConnectionArea(id,rmAreaID("middle"));
		rmBuildConnection(id);
	}
	
	//Build Areas
	
	rmBuildArea(rmAreaID("middle"));
	for(i = 1; <= c) {
		rmBuildArea(rmAreaID("playerareaA"+i));
		rmBuildArea(rmAreaID("playerareaB"+i));
	}
	
	//Further Areas
	
	id = rmCreateArea("middle2");
	rmSetAreaTerrainType(id,terrainMiddle);
	rmSetAreaBaseHeight(id,10);
	rmSetAreaCoherence(id,1.0);
	rmSetAreaHeightBlend(id,2);
	rmSetAreaLocation(id,0.5,0.5);
	rmSetAreaSize(id,0.003,0.003);
	rmSetAreaSmoothDistance(id,5);
	rmBuildArea(id);
	
	for(i = 1; <= c) {
		id = rmCreateArea("spawnArea"+i);
		rmSetAreaCoherence(id,1.0);
		rmSetAreaLocation(id,circlex(0.5, c, i, 0.28, 0), circley(0.5, c, i, 0.28, 0));
		rmSetPlayerArea(i,id);
		rmSetAreaTerrainType(id,"CityTileWaterPool");
		rmSetAreaBaseHeight(id,5);
		rmSetAreaHeightBlend(id,2);
		rmSetAreaSize(id,0.001,0.001);
		rmBuildArea(id);
	}
	
	for(i = 1; <= c) {
		id = rmCreateArea("chooseAreaA"+i);
		rmSetAreaCoherence(id,1.0);
		rmSetAreaLocation(id,circlex(0.5, c, i, 0.45, -360 / (c * 4)), circley(0.5, c, i, 0.45, -360 / (c * 4)));
		rmSetPlayerArea(i,id);
		rmSetAreaTerrainType(id,terrain);
		rmSetAreaBaseHeight(id,5);
		rmSetAreaHeightBlend(id,2);
		rmSetAreaSize(id,0.008,0.008);
		rmBuildArea(id);
	}
	
	for(i = 1; <= c) {
		id = rmCreateArea("chooseAreaB"+i);
		rmSetAreaCoherence(id,1.0);
		rmSetAreaLocation(id,circlex(0.5, c, i, 0.45, 360 / (c * 4)), circley(0.5, c, i, 0.45, 360 / (c * 4)));
		rmSetPlayerArea(i,id);
		rmSetAreaTerrainType(id,terrain);
		rmSetAreaBaseHeight(id,5);
		rmSetAreaHeightBlend(id,2);
		rmSetAreaSize(id,0.008,0.008);
		rmBuildArea(id);
	}
	
	//Place Units
	
	id = rmCreateObjectDef("centreUnit");
	rmAddObjectDefItem(id,"Revealer to Player",1,0.0);
	rmPlaceObjectDefAtAreaLoc(id, 0, rmAreaID("middle"), 1);
	
	for(i = 1; <= c){
		id = rmCreateObjectDef("unitSpawn"+i);
		rmAddObjectDefItem(id,"Titan Gaia",1,5.0);
		for(j = 1; <= 4) {
			rmPlaceObjectDefAtLoc(id, 0, circlex(circlex(0.5, c, i, 0.45, -360 / (c * 4)), 4, j, 0.05, 0), circley(circley(0.5, c, i, 0.45, -360 / (c * 4)), 4, j, 0.05, 0),1);
		}
	}
	
	for(i = 1; <= c){
		id = rmCreateObjectDef("shop"+i);
		rmAddObjectDefItem(id,"Titan Gaia",1,5.0);
		for(j = 1; <= 4) {
			rmPlaceObjectDefAtLoc(id, 0, circlex(circlex(0.5, c, i, 0.45, 360 / (c * 4)), 4, j, 0.05, 0), circley(circley(0.5, c, i, 0.45, 360 / (c * 4)), 4, j, 0.05, 0),1);
		}
	}
	
	for(i = 1; <= c) {
		id = rmCreateObjectDef("spawnBlock"+i);
		rmAddObjectDefItem(id,"Cinematic Block",1,0.0);
		rmPlaceObjectDefAtLoc(id, i, circlex(0.5, c, i, 0.28, 0), circley(0.5, c, i, 0.28, 0),1);
	}
	
	for(i = 1; <= c) {
		id = rmCreateObjectDef("wonder"+i);
		rmAddObjectDefItem(id,"Wonder SPC",1,0.0);
		rmPlaceObjectDefAtLoc(id, i, circlex(0.5, c, i, 0.32, 0), circley(0.5, c, i, 0.32, 0),1);
	}	
	
	for(i = 1; <= c) {
		id = rmCreateObjectDef("tower"+i);
		rmAddObjectDefItem(id,"Tower",1,0.0);
		for(j = 1; <= 12) {
			rmPlaceObjectDefAtLoc(id, i, circlex(circlex(0.5, c, i, 0.3, 0), 12, j, 0.06, 0), circley(circley(0.5, c, i, 0.3, 0), 12, j, 0.06, 0),1);
		}
	}
	
	for(i = 1; <= c) {
		id = rmCreateObjectDef("chooserUnitA"+i);
		rmAddObjectDefItem(id,"Old Man",1,0.0);
		rmPlaceObjectDefAtAreaLoc(id, i, rmAreaID("chooseAreaA"+i), 1);
	}	
	
	for(i = 1; <= c) {
		id = rmCreateObjectDef("chooserUnitB"+i);
		rmAddObjectDefItem(id,"Athena",1,0.0);
		rmPlaceObjectDefAtAreaLoc(id, i, rmAreaID("chooseAreaB"+i), 1);
	}
	
	for(i = 1; <= c) {
		id = rmCreateObjectDef("healingSpring"+i);
		rmAddObjectDefItem(id,"Tower Mirror",1,0.0);
		rmPlaceObjectDefAtAreaLoc(id, 0, rmAreaID("playerareaB"+i), 1);
	}

	string quote = "\\";
	
	rmSwitchToTrigger(rmCreateTrigger("t"));
	con("(trTime()-cActivationTime) >= 0");
	//custom event handler!
	code("trEventSetHandler(2, \"e\");");
	code("}}void e(int id=-1){if(id==2){xsEnableRule(\"_m\");}} rule _a active {if(true){");
	rmSetTriggerPriority(4);
	rmSetTriggerActive(true);
	rmSetTriggerRunImmediately(true);
	rmSetTriggerLoop(false);
	
	rmSwitchToTrigger(rmCreateTrigger("m"));
	code("trPlayNextMusicTrack();");
	rmSetTriggerPriority(4);
	rmSetTriggerActive(false);
	rmSetTriggerRunImmediately(false);
	rmSetTriggerLoop(false);

	rmSwitchToTrigger(rmCreateTrigger("immediate"));
	con("(trTime()-cActivationTime) >= 0");
	for(p = 1; <= c) {
		for(u = 0; < 4) {
			code("trUnitSelectClear();");
			code("trUnitSelect(\""+((p-1) * 4 + u + 1)+"\");");
			code("trUnitChangeProtoUnit(\""+getUnit(1, u)+"\");");
		}
		for(power = 0; < 4) {
			code("trUnitSelectClear();");
			code("trUnitSelect(\""+((p-1) * 4 + power + 1 + c * 4)+"\");");
			if(powerCost(getPower(power)) == powerCost1)code("trUnitChangeProtoUnit(\"Monument\");");
			if(powerCost(getPower(power)) == powerCost2)code("trUnitChangeProtoUnit(\"Monument 2\");");
			if(powerCost(getPower(power)) == powerCost3)code("trUnitChangeProtoUnit(\"Monument 3\");");
			if(powerCost(getPower(power)) == powerCost4)code("trUnitChangeProtoUnit(\"Monument 4\");");
			if(powerCost(getPower(power)) == powerCost5)code("trUnitChangeProtoUnit(\"Monument 5\");");
		}
		code("trQuestVarSet(\"level"+p+"\", 1);");
	}
	code("trSetDisableGPBlocking(true);");
	rmSetTriggerPriority(4);
	rmSetTriggerActive(true);
	rmSetTriggerRunImmediately(true);
	rmSetTriggerLoop(false);

	rmSwitchToTrigger(rmCreateTrigger("delayed"));
	con("(trTime()-cActivationTime) >= 0");
	code("for(p = 1; <= "+c+") {");
		code("trTechGodPowerAtPosition(p, \"Change Caladria\", 1, 1);");
		code("trTechGodPowerAtPosition(p, \"Change Caladria\", -1, 1);");
		code("trTechGodPowerAtPosition(p, \"Change Chimera\", 1, 2);");
		code("trTechGodPowerAtPosition(p, \"Change Chimera\", -1, 2);");
		code("trTechGodPowerAtPosition(p, \"Change Cyclops\", 1, 3);");
		code("trTechGodPowerAtPosition(p, \"Change Cyclops\", -1, 3);");
		code("trTechGodPowerAtPosition(p, \"Change Hydra\", 1, 4);");
		code("trTechGodPowerAtPosition(p, \"Change Hydra\", -1, 4);");
		code("trPlayerSetDiplomacy(p,0,\"Neutral\");");
	code("}");
	code("for(p = 1; <= "+c+") {");
		code("trPlayerGrantResources(p, \"Food\", -100000000.0);");
		code("trPlayerGrantResources(p, \"Wood\", -100000000.0);");
		code("trPlayerGrantResources(p, \"Gold\", -100000000.0);");
		code("trPlayerGrantResources(p, \"Favor\", -100000000.0);");
		code("trForbidProtounit(p, \"Settlement Level 1\");");
		code("trForbidProtounit(p, \"Guild\");");
		code("trForbidProtounit(p, \"Dock\");");
		code("trForbidProtounit(p, \"Temple\");");
		code("trForbidProtounit(p, \"Armory\");");
		code("trForbidProtounit(p, \"Market\");");
		code("trForbidProtounit(p, \"Dwarf Foundry\");");
		code("trForbidProtounit(p, \"Wonder\");");
		code("trForbidProtounit(p, \"Manor\");");
		code("trForbidProtounit(p, \"Farm\");");
		code("trForbidProtounit(p, \"Tower\");");
		code("trForbidProtounit(p, \"Sky Passage\");");
		code("trForbidProtounit(p, \"Dryad\");");
		code("trForbidProtounit(p, \"Wall Connector\");");
		code("trForbidProtounit(p, \"House\");");
		code("trForbidProtounit(p, \"Longhouse\");");
		code("trTechSetStatus(p, 0, 4);");
		code("trTechSetStatus(p, 1, 4);");
		code("trTechSetStatus(p, 2, 4);");
		code("trTechSetStatus(p, 116, 4);");
		code("trTechSetStatus(p, 443, 4);");
		code("trTechGodPowerAtPosition(p, \"TitanGate\", -1, 5);");
		code("trTechSetStatus(p, 480, 4);");
		code("trTechSetStatus(p, 27, 4);");
		code("trTechSetStatus(p, 28, 4);");
		code("trTechSetStatus(p, 127, 4);");
		code("trTechSetStatus(p, 350, 4);");
		code("trTechSetStatus(p, 30, 4);");
		code("trTechSetStatus(p, 411, 0);");
		code("trTechSetStatus(p, 67, 0);");
		code("trTechSetStatus(p, 126, 0);");
		code("trTechSetStatus(p, 140, 0);");
		code("trTechSetStatus(p, 29, 0);");
	code("}");
	
	modifyProtounitAbsolute("Revealer to Player", 0, 2, 1000.0);
	modifyProtounitAbsolute("Revealer to Player", 0, 24, 1.0);
	modifyProtounitAbsolute("Revealer to Player", 0, 25, 1.0);
	modifyProtounitAbsolute("Revealer to Player", 0, 26, 1.0);
	for(p = 1; <= c) {
		modifyProtounitAbsolute("Old Man", p, 0, 999999999.0);
		modifyProtounitAbsolute("Athena", p, 0, 999999999.0);
		modifyProtounitAbsolute("Old Man", p, 1, 10.0);
		modifyProtounitAbsolute("Athena", p, 1, 10.0);
		modifyProtounitAbsolute("Old Man", p, 2, rmXFractionToMeters(0.1));
		modifyProtounitAbsolute("Athena", p, 2, rmXFractionToMeters(0.1));
		modifyProtounitAbsolute("Raven", p, 0, 10000.0);
		modifyProtounitAbsolute("Raven", p, 1, 5.0);
		modifyProtounitAbsolute("Bolt Scorch", p, 2, 10.0);
		modifyProtounitAbsolute("Wonder SPC", p, 24, 0.7);
		modifyProtounitAbsolute("Wonder SPC", p, 25, 0.9);
		modifyProtounitAbsolute("Wonder SPC", p, 26, 0.5);
		modifyProtounitAbsolute("Wonder SPC", p, 0, 10000.0);
		modifyProtounitAbsolute("Tower", p, 0, 1000.0);
	}
	for(u = 0; < 4) {
		modifyProtounitAbsolute("Monument", 0, 0, 999999999.0);
		modifyProtounitAbsolute("Monument 2", 0, 0, 999999999.0);
		modifyProtounitAbsolute("Monument 3", 0, 0, 999999999.0);
		modifyProtounitAbsolute("Monument 4", 0, 0, 999999999.0);
		modifyProtounitAbsolute("Monument 5", 0, 0, 999999999.0);
		for(level = 1; <= levels) {
			modifyProtounitAbsolute(getUnit(level, u), 0, 0, 999999999.0);
			modifyProtounitAbsolute(getUnit(level, u), 0, 1, 0.0);
			modifyProtounitAbsolute(getUnit(level, u), 0, 2, 0.0);
			for(p = 1; <= c) {
				modifyProtounitAbsolute(getUnit(level, u), p, 6, 1);
			}
		}
		for(p = 1; <= c) {
			modifyProtounitAbsolute(getUnit(levels, u), p, 0, 10000.0);
			modifyProtounitAbsolute(getUnit(levels, u), p, 11, 50.0);
			modifyProtounitAbsolute(getUnit(levels, u), p, 2, 60.0);
			modifyProtounitAbsolute(getUnit(levels, u), p, 28, 10000.0);
			modifyProtounitAbsolute(getUnit(levels, u), p, 31, 10000.0);
		}
	}
	rmSetTriggerPriority(4);
	rmSetTriggerActive(true);
	rmSetTriggerRunImmediately(false);
	rmSetTriggerLoop(false);

	rmSwitchToTrigger(rmCreateTrigger("delayed2"));
	con("(trTime()-cActivationTime) >= 1");
	code("trRevealEntireMap();");
	code("trTechInvokeGodPower(0,\"Hesperides\",vector("+(0.5 * mapSize)+", 0.0, "+(0.5 * mapSize)+"),vector(0.0, 0.0, 0.0));");
	rmSetTriggerPriority(4);
	rmSetTriggerActive(true);
	rmSetTriggerRunImmediately(false);
	rmSetTriggerLoop(false);
	
	for(p = 1; <= c) {
		for(u = 0; < 4) {
			for(level = 1; <= levels) {
				rmSwitchToTrigger(rmCreateTrigger("deployP"+p+"U"+u+"Level"+level));
				con("(trTime()-cActivationTime) >= 3");
				con("trQuestVarGet(\"level"+p+"\") == "+level+"");
				con("(trPlayerGetPopulation("+p+") < 80) || ("+level+" == "+levels+")");
				code("if(trCountUnitsInArea(\""+((p-1) * 4 + u + 1)+"\","+p+",\"Old Man\", 8.0) >= 1){");
					if(level < levels){
						code("trArmyDispatch(\""+p+",0\", \""+getUnit(level, u)+"\", 5, "+rmXFractionToMeters(circlex(0.5, c, p, 0.28, 0))+",0,"+rmZFractionToMeters(circley(0.5, c, p, 0.28, 0))+", 0, true);");
					} else {
						code("trArmyDispatch(\""+p+",0\", \"Raven\", 1, "+rmXFractionToMeters(circlex(0.5, c, p, 0.28, 0))+",0,"+rmZFractionToMeters(circley(0.5, c, p, 0.28, 0))+", 0, true);");
						code("trQuestVarSet(\"finalUnit"+p+"\", "+u+");");
					}
				code("}");
				rmSetTriggerPriority(4);
				rmSetTriggerActive(true);
				rmSetTriggerRunImmediately(false);
				rmSetTriggerLoop(true);
			}
		}
	}
	
	for(p = 1; <= c) {
		for(level = 2; <= levels) {
			rmSwitchToTrigger(rmCreateTrigger("levelUp"+p+"Level"+level));
			con("trQuestVarGet(\"points"+p+"\") >= "+(100 * (level-1))+"");
			code("trQuestVarSet(\"level"+p+"\", "+level+");");
			for(u = 0; < 4) {
				code("trUnitSelectClear();");
				code("trUnitSelect(\""+((p-1) * 4 + u + 1)+"\");");
				code("trUnitChangeProtoUnit(\""+getUnit(level, u)+"\");");
				if(level == levels){
					code("trTechInvokeGodPower(0,\"Tremor\",kbGetBlockPosition(\""+((p-1) * 4 + u + 1)+"\"), vector(0.0, 0.0, 0.0));");
				}
			}
			code("trSoundPlayPaused(\"cinematics\15_in\gong.wav\",\"1\",-1,\"\",\"\");");
			code("trChatSendToPlayer(0, "+p+", \"<color=0,1,0>Choose new units</color>\");");
			code("trOverlayTextColour("+playerColor(p,1)+", "+playerColor(p,2)+", "+playerColor(p,3)+");");
			code("trOverlayText(\""+rmGetPlayerName(p)+" is now level "+level+" / "+levels+"\",5,-1,-1,-1);");
			if(level == levels){
				code("trSoundPlayPaused(\"dialog\en\garg119.mp3\",\"1\",-1,\"\",\"\");");
				code("trOverlayText(\""+rmGetPlayerName(p)+" IS TOP LEVEL - WATCHOUT!\",8,-1,-1,-1);");
				code("if(trCurrentPlayer() == "+p+")uiFindType(\"Old Man\");");
				code("sunColor(255, 0, 0);");
				code("trSetLighting(\"Default\",5.0);");
				code("trChatSendToPlayer(0, "+p+", \"<color=1,0,0>Use the ravens to move the spawned buildings.</color>\");");
			} else {
				code("trOverlayText(\""+rmGetPlayerName(p)+" is now level "+level+" / "+levels+"\",5,-1,-1,-1);");
			}
			rmSetTriggerPriority(4);
			rmSetTriggerActive(true);
			rmSetTriggerRunImmediately(false);
			rmSetTriggerLoop(false);
		}
	}
	
	for(p = 1; <= c) {
		for(power = 0; < 4) {
			rmSwitchToTrigger(rmCreateTrigger("shopSelectP"+p+"Power"+power));
			code("trUnitSelectClear();");
			code("trUnitSelect(\""+((p-1) * 4 + power + 1 + c * 4)+"\");");
			code("if(trUnitIsSelected()){");
				code("uiClearSelection();");
				code("trMessageSetText(\""+powerDescription(getPower(power))+" - "+powerCost(getPower(power))+" Gold\", 5000);");
			code("}");
			rmSetTriggerPriority(4);
			rmSetTriggerActive(true);
			rmSetTriggerRunImmediately(false);
			rmSetTriggerLoop(true);
			
			rmSwitchToTrigger(rmCreateTrigger("shopP"+p+"Power"+power));
			con("(trTime()-cActivationTime) >= 3");
			con("trPlayerResourceCount("+p+", \"Gold\") >= "+powerCost(getPower(power))+"");
			code("if(trCountUnitsInArea(\""+((p-1) * 4 + power + 1 + c * 4)+"\","+p+",\"Athena\", 5.0) >= 1){");
				code("trTechGodPowerAtPosition("+p+", \""+powerName(getPower(power))+"\", 1, "+(power + 1)+");");
				code("trPlayerGrantResources("+p+", \"Gold\", -"+powerCost(getPower(power))+");");
				code("trChatSendToPlayer(0, "+p+", \"<color=1,1,1>"+powerDescription(getPower(power))+" </color><color=1,0,0>purchased</color>\");");
			code("}");
			rmSetTriggerPriority(4);
			rmSetTriggerActive(true);
			rmSetTriggerRunImmediately(false);
			rmSetTriggerLoop(true);
		}
	}
	
	rmSwitchToTrigger(rmCreateTrigger("loops1"));
	con("(trTime()-cActivationTime) >= 1");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"0\");");
	code("for(p = 1; <= "+c+"){");
		code("trDamageUnitsInArea(p,\"Wonder SPC\",999.0, -25);");
	
		code("int lossesDiff = trGetStatValue(p, 6) - trQuestVarGet(\"countedLosses\"+p);");
		code("trPlayerGrantResources(p, \"Gold\", lossesDiff);");
		code("trQuestVarSet(\"countedLosses\"+p, trGetStatValue(p, 6));");
		
		code("int diff = trGetStatValue(p, 2) - trQuestVarGet(\"countedKills\"+p);");
		code("trQuestVarSet(\"points\"+p, trQuestVarGet(\"points\"+p) + diff);");
		code("trQuestVarSet(\"countedKills\"+p, trGetStatValue(p, 2));");
		code("if(trCurrentPlayer() == p){");
			code("trSetCounterDisplay(\"Points: \" + (1*trQuestVarGet(\"points\"+p)));");
		code("}");
	code("}");
	rmSetTriggerPriority(4);
	rmSetTriggerActive(true);
	rmSetTriggerRunImmediately(false);
	rmSetTriggerLoop(true);	
	
	rmSwitchToTrigger(rmCreateTrigger("loops2"));
	con("(trTime()-cActivationTime) >= 2");
	code("for(p = 1; <= "+c+"){");
		code("trQuestVarSet(\"points\"+p, trQuestVarGet(\"points\"+p) + trPlayerUnitCountSpecific(p, \"Hesperides Tree\"));");
	code("}");
	rmSetTriggerPriority(4);
	rmSetTriggerActive(true);
	rmSetTriggerRunImmediately(false);
	rmSetTriggerLoop(true);	
	
	rmSwitchToTrigger(rmCreateTrigger("loops3"));
	con("(trTime()-cActivationTime) >= 3");
	code("for(p = 1; <= "+c+"){");
		code("trPlayerGrantResources(p, \"Gold\", 1.0);");
	code("}");
	rmSetTriggerPriority(4);
	rmSetTriggerActive(true);
	rmSetTriggerRunImmediately(false);
	rmSetTriggerLoop(true);
	
	for(p = 1; <= c){
		rmSwitchToTrigger(rmCreateTrigger("lose" + p));
		con("trPlayerUnitCountSpecific("+p+", \"Wonder SPC\") < 1");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"0\");");
		code("trUnitChangeInArea("+p+", 0, \"Healing Spring Object\", \"Healing Spring Object\", 9999.0);");
		code("trUnitChangeInArea("+p+", 0, \"Hesperides Tree\", \"Hesperides Tree\", 9999.0);");
		code("trSoundPlayPaused(\"xpack\xdialog\ko\xkri075.mp3\",\"1\",-1,\"\",\"\");");
		code("trOverlayTextColour("+playerColor(p,1)+", "+playerColor(p,2)+", "+playerColor(p,3)+");");
		code("trOverlayText(\""+rmGetPlayerName(p)+" has been defeated!\",5,-1,-1,-1);");
		code("trPlayerKillAllBuildings("+p+");");
		code("trPlayerKillAllUnits("+p+");");
		code("trSetPlayerDefeated("+p+");");
		code("if(trCurrentPlayer() == "+p+")trSoundPlayPaused(\"cinematics\9_out\music.mp3\",\"1\",-1,\"\",\"\");");
		rmSetTriggerPriority(4);
		rmSetTriggerActive(true);
		rmSetTriggerRunImmediately(false);
		rmSetTriggerLoop(false);
	}	
	
	for(p = 1; <= c){
		rmSwitchToTrigger(rmCreateTrigger("respawnOldMan" + p));
		con("trPlayerUnitCountSpecific("+p+", \"Wonder SPC\") >= 1");
		con("trPlayerUnitCountSpecific("+p+", \"Old Man\") < 1");
		code("trArmyDispatch(\""+p+",0\",\"Old Man\",1,"+rmXFractionToMeters(circlex(0.5, c, p, 0.45, -360 / (c * 4)))+",0,"+rmZFractionToMeters(circley(0.5, c, p, 0.45, -360 / (c * 4)))+",0,true);");
		rmSetTriggerPriority(4);
		rmSetTriggerActive(true);
		rmSetTriggerRunImmediately(false);
		rmSetTriggerLoop(true);
	}
	
	for(p = 1; <= c){
		rmSwitchToTrigger(rmCreateTrigger("respawnAthena" + p));
		con("trPlayerUnitCountSpecific("+p+", \"Wonder SPC\") >= 1");
		con("trPlayerUnitCountSpecific("+p+", \"Athena\") < 1");
		code("trArmyDispatch(\""+p+",0\",\"Athena\",1,"+rmXFractionToMeters(circlex(0.5, c, p, 0.45, 360 / (c * 4)))+",0,"+rmZFractionToMeters(circley(0.5, c, p, 0.45, 360 / (c * 4)))+",0,true);");
		rmSetTriggerPriority(4);
		rmSetTriggerActive(true);
		rmSetTriggerRunImmediately(false);
		rmSetTriggerLoop(true);
	}
	
	rmSwitchToTrigger(rmCreateTrigger("search"));
	//SEARCH SETUP START
	code("if(trQuestVarGet(\"lastActivation\") <= trTimeMS()){");
	code("trQuestVarSet(\"lastActivation\", trTimeMS() + 250);");
	code("for(buf = 0; > 1){}");
	code("buf = 10;");
	code("if(1*trQuestVarGet(\"rebootNeeded\") == 1){");
	code("trQuestVarSet(\"rebootNeeded\", 0);");
	code("buf = 10000;");
	code("}");
	code("trQuestVarSet(\"lastSearchId\", 1*trQuestVarGet(\"cow\"));");
	code("trArmyDispatch(\"0,0\",\"Oar Footprint\",1,5.0,0,5.0,0,true);");
	code("for(type = 0; > 1){}");
	code("for(i = 0; > 1){}");
	code("if(0 >= 1*trQuestVarGet(\"cow\"))trQuestVarSet(\"cow\", (0)+1);");
	code("while(buf >= i){");
	code("if(kbGetUnitBaseTypeID(kbGetBlockID(\"\"+1*trQuestVarGet(\"cow\"))) == -1){");
	code("i = i + 1;}");
	code("if(kbGetUnitBaseTypeID(kbGetBlockID(\"\"+1*trQuestVarGet(\"cow\"))) != -1){");
	code("i = 0;");
	code("type = kbGetUnitBaseTypeID(kbGetBlockID(\"\"+1*trQuestVarGet(\"cow\")));");
	//code("if(type != kbGetProtoUnitID(\"Blood Gore\")){");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"));");
	code("vector v = kbGetBlockPosition(\"\"+1*trQuestVarGet(\"cow\"));");
	code("float x = xsVectorGetX(kbGetBlockPosition(\"\"+1*trQuestVarGet(\"cow\")));");
	code("float z = xsVectorGetZ(kbGetBlockPosition(\"\"+1*trQuestVarGet(\"cow\")));");
	//MAIN CODE
	code("if(type == kbGetProtoUnitID(\"Animal Attractor\")){");
		code("trUnitChangeProtoUnit(\"Tower\");");
	code("}");
	code("if(type == kbGetProtoUnitID(\"Bolt Scorch\")){");
		code("for(p = 1; <= "+c+"){");
			code("if(trUnitIsOwnedBy(p)){");
				code("trTechGodPowerAtPosition(p, \"TitanGate\", 1, 5);");
				code("trTechGodPowerAtPosition(p, \"Tremor\", 1, 5);");
				code("trTechInvokeGodPower(p,\"Tremor\",v,v);");
			code("}");
		code("}");
	code("}");
	code("if(type == kbGetProtoUnitID(\"Tremor\")){");
		code("if(trUnitVisToPlayer()==true)trSoundPlayPaused(\"Converting.wav\",\"-1\",-1,\"\",\"\");");
		code("for(p = 1; <= "+c+"){");
			code("if(trUnitIsOwnedBy(p))trQuestVarSet(\"tremorKills\", p);");
		code("}");
	code("}");
	code("if(type == kbGetProtoUnitID(\"Shockwave Stun Effect\")){");
		code("if(trUnitVisToPlayer()==true)trSoundPlayPaused(\"Converted.wav\",\"-1\",-1,\"\",\"\");");
		code("for(p = 1; <= "+c+"){");
			code("if(trUnitIsOwnedBy(p))trPlayerGrantResources(p, \"Gold\", 1);");
			code("if(p != trQuestVarGet(\"tremorKills\"))trUnitChangeInArea(p, p, \"Unit\", \"Conversion Sfx\", 1.0);");
		code("}");
		code("trQuestVarSet(\"points\"+(1*trQuestVarGet(\"tremorKills\")),trQuestVarGet(\"points\"+(1*trQuestVarGet(\"tremorKills\")))+1);");
	code("}");
	code("if(type == kbGetProtoUnitID(\"Ice Sheet\")){");
		code("if(trUnitVisToPlayer()==true)trSoundPlayPaused(\"cinematics\13_out\pray2.mp3\",\"-1\",-1,\"\",\"\");");
		code("for(p = 1; <= "+c+"){");
			code("if(trUnitIsOwnedBy(p))trQuestVarSet(\"frostKills\", p);");
		code("}");
	code("}");
	code("if(type == kbGetProtoUnitID(\"Ice Block\")){");
		code("if(trUnitVisToPlayer()==true)trSoundPlayPaused(\"cinematics\25_out\boyz.mp3\",\"-1\",-1,\"\",\"\");");
		code("for(p = 1; <= "+c+"){");
			code("if(trUnitIsOwnedBy(p))trPlayerGrantResources(p, \"Gold\", 1);");
			code("if(p != trQuestVarGet(\"frostKills\"))trUnitChangeInArea(p, p, \"Unit\", \"Curse Sfx\", 1.0);");
		code("}");
		code("trQuestVarSet(\"points\"+(1*trQuestVarGet(\"frostKills\")),trQuestVarGet(\"points\"+(1*trQuestVarGet(\"frostKills\")))+1);");
	code("}");
	code("if(type == kbGetProtoUnitID(\"Nidhogg\")){");
		code("trUnitChangeProtoUnit(\"Pharaoh of Osiris\");");
	code("}");
	code("if(type == kbGetProtoUnitID(\"Raven\")){");
		code("trTechInvokeGodPower(p,\"Spy\",v,v);");
	code("}");
	code("if(type == kbGetProtoUnitID(\"Spy Eye\")){");
		code("trUnitChangeProtoUnit(\"Ajax\");");
		for(p = 1; <= c){
			code("trUnitSelectClear();");
			code("trUnitSelect(\""+(p + c * 8)+"\");");
			code("if(trQuestVarGet(\"finalUnit"+p+"\")==0)trUnitChangeInArea(0, "+p+", \"Ajax\", \""+getUnit(levels, 0)+"\", 40.0);");
			code("if(trQuestVarGet(\"finalUnit"+p+"\")==1)trUnitChangeInArea(0, "+p+", \"Ajax\", \""+getUnit(levels, 1)+"\", 40.0);");
			code("if(trQuestVarGet(\"finalUnit"+p+"\")==2)trUnitChangeInArea(0, "+p+", \"Ajax\", \""+getUnit(levels, 2)+"\", 40.0);");
			code("if(trQuestVarGet(\"finalUnit"+p+"\")==3)trUnitChangeInArea(0, "+p+", \"Ajax\", \""+getUnit(levels, 3)+"\", 40.0);");
		}
	code("}");
	code("if(type == kbGetProtoUnitID(\"Minion\")){");
		code("for(p = 1; <= "+c+"){");
			code("if(trUnitIsOwnedBy(p))trQuestVarSet(\"points\"+p, trQuestVarGet(\"points\"+p) + 1);");
		code("}");
	code("}");
	code("if(type == kbGetProtoUnitID(\"Acid Pool\")){");
		code("for(p = 1; <= "+c+"){");
			code("if(trCountUnitsInArea(\"\"+(1*trQuestVarGet(\"cow\")),p,\"Argus\", 5.0) >= 1){");
				code("trQuestVarSet(\"points\"+p, trQuestVarGet(\"points\"+p) + 1);");
			code("}");
		code("}");
	code("}");
	code("if(type == kbGetProtoUnitID(\"Chaos Effect\")){");
		code("for(p = 1; <= "+c+"){");
			code("if(trCountUnitsInArea(\"\"+(1*trQuestVarGet(\"cow\")),p,\"Lampades\", 10.0) >= 1){");
				code("trQuestVarSet(\"points\"+p, trQuestVarGet(\"points\"+p) + 1);");
			code("}");
		code("}");
		code("trUnitChangeInArea(0, 0, \"Unit\", \"Kronny Birth Sfx\", 1.0);");
	code("}");
	code("if(type == kbGetProtoUnitID(\"Wave\")){");
		code("if(trCountUnitsInArea(\"\"+(1*trQuestVarGet(\"cow\")),0,\"Unit\", 15.0) < 1){");
			code("if(trCountUnitsInArea(\"\"+(1*trQuestVarGet(\"cow\")),0,\"Building\", 15.0) < 1){");
				code("trQuestVarSetFromRand(\"r\", 1, 5, true);");
				code("trQuestVarSetFromRand(\"n\", 1, 3, true);");
				code("if(trQuestVarGet(\"r\") == 1){");
					code("for(i = 1; <= trQuestVarGet(\"n\")){");
						code("trQuestVarSetFromRand(\"h\", 1, 360, true);");
						code("trArmyDispatch(\"0,0\",\""+tree+"\",trQuestVarGet(\"n\"),x,0,z,trQuestVarGet(\"h\"),true);");
					code("}");
				code("}");
			code("}");
		code("}");
	code("}");
	code("if(type == kbGetProtoUnitID(\"Tower Mirror\")){");
		code("trUnitChangeProtoUnit(\"Osiris Box Glow\");");
		code("trTechInvokeGodPower(p,\"Healing Spring\",v,v);");
	code("}");
	code("if(type == kbGetProtoUnitID(\"Militia\")){");
		code("trUnitChangeProtoUnit(\"Osiris Box Glow\");");
	code("}");
	code("if(type == kbGetProtoUnitID(\"Audrey\") || type == kbGetProtoUnitID(\"Audrey Water\")){");
		code("for(p = 1; <= "+c+"){");
			code("if(trUnitIsOwnedBy(p)){");
				code("trTechGodPowerAtPosition(p, \"TitanGate\", 1, 5);");
				code("trTechGodPowerAtPosition(p, \"Flaming Weapons\", 1, 5);");
				code("trTechInvokeGodPower(p,\"Flaming Weapons\",v,v);");
			code("}");
		code("}");
		code("trUnitChangeProtoUnit(\"Olympus Temple Sfx\");");
	code("}");
	code("if(type == kbGetProtoUnitID(\"Audrey Base\") || type == kbGetProtoUnitID(\"Audrey Water Base\")){");
		code("trUnitChangeProtoUnit(\"Arkantos God Out\");");
	code("}");
	//SEARCH END CODE
	//code("}");
	code("}");
	code("trQuestVarSet(\"cow\", 1*trQuestVarGet(\"cow\")+1);}");
	code("trQuestVarSet(\"cow\", 1*trQuestVarGet(\"cow\") - (buf + 1));");
	//code("trArmySelect(\"0,0\");");
	//code("trUnitDelete();");
	code("if(1*trQuestVarGet(\"cow\") == 1*trQuestVarGet(\"lastSearchId\"))trQuestVarSet(\"rebootNeeded\", 1);");
	code("}");
	rmSetTriggerPriority(4);
	rmSetTriggerActive(true);
	rmSetTriggerRunImmediately(false);
	rmSetTriggerLoop(true);
	
	rmSwitchToTrigger(rmCreateTrigger("cine1"));
	con("(trTime()-cActivationTime) >= 0");
	code("trSetFogAndBlackmap(false, false);");
	code("trLetterBox(true);");
	code("trSoundPlayFN(\"xpack\xcinematics\intro\music.mp3\",\"1\",2,\"\",\"\");");
	code("trOverlayTextColour(0,255,255);");
	code("trOverlayText(\"Mythodea - By Nottud\",5,-1,-1,-1);");
	code("trUIFadeToColor(0,0,0,1000,4000,false);");
	rmSetTriggerPriority(4);
	rmSetTriggerActive(true);
	rmSetTriggerRunImmediately(true);
	rmSetTriggerLoop(false);
	
	rmSwitchToTrigger(rmCreateTrigger("cine2"));
	con("(trTime()-cActivationTime) >= 4");
	code("trBlockAllSounds(true);");
	code("uiFindType(\"Old Man\");");
	code("trUnblockAllSounds();");
	code("trSoundPlayFN(\"\",\"1\",-1,\"Nottud:Use the old man to select a unit to spawn in your base.\",\"\");");
	rmSetTriggerPriority(4);
	rmSetTriggerActive(true);
	rmSetTriggerRunImmediately(false);
	rmSetTriggerLoop(false);	
	
	rmSwitchToTrigger(rmCreateTrigger("cine3"));
	con("(trTime()-cActivationTime) >= 9");
	code("trBlockAllSounds(true);");
	code("uiFindType(\"Wonder SPC\");");
	code("trUnblockAllSounds();");
	code("trSoundPlayFN(\"\",\"1\",-1,\"Nottud:Use your spawned units and gain 1 point for every kill.\",\"\");");
	rmSetTriggerPriority(4);
	rmSetTriggerActive(true);
	rmSetTriggerRunImmediately(false);
	rmSetTriggerLoop(false);
	
	rmSwitchToTrigger(rmCreateTrigger("cine4"));
	con("(trTime()-cActivationTime) >= 14");
	code("lookAt("+(0.5 * mapSize)+","+(0.5 * mapSize)+");");
	code("trSoundPlayFN(\"\",\"1\",-1,\"Nottud:Also capture tree for 1 point every 2 seconds - level up every 100 points.\",\"\");");
	rmSetTriggerPriority(4);
	rmSetTriggerActive(true);
	rmSetTriggerRunImmediately(false);
	rmSetTriggerLoop(false);
	
	rmSwitchToTrigger(rmCreateTrigger("cine5"));
	con("(trTime()-cActivationTime) >= 19");
	code("trBlockAllSounds(true);");
	code("uiFindType(\"Athena\");");
	code("trUnblockAllSounds();");
	code("trSoundPlayFN(\"\",\"1\",-1,\"Nottud:Use gold given slowly and from losses to purchase powers to help you.\",\"\");");
	rmSetTriggerPriority(4);
	rmSetTriggerActive(true);
	rmSetTriggerRunImmediately(false);
	rmSetTriggerLoop(false);
	
	rmSwitchToTrigger(rmCreateTrigger("cine6"));
	con("(trTime()-cActivationTime) >= 24");
	code("trBlockAllSounds(true);");
	code("uiFindType(\"Wonder SPC\");");
	code("trUnblockAllSounds();");
	code("trSoundPlayFN(\"\",\"1\",-1,\"Nottud:Protect your wonder at all costs otherwise you will lose.\",\"\");");
	rmSetTriggerPriority(4);
	rmSetTriggerActive(true);
	rmSetTriggerRunImmediately(false);
	rmSetTriggerLoop(false);
	
	rmSwitchToTrigger(rmCreateTrigger("cine7"));
	con("(trTime()-cActivationTime) >= 29");
	code("trBlockAllSounds(true);");
	code("uiFindType(\"Old Man\");");
	code("trUnblockAllSounds();");
	code("trLetterBox(false);");
	code("trSetFogAndBlackmap(true, true);");
	code("trOverlayTextColour(0,255,0);");
	code("trOverlayText(\"Good Luck - Units and powers are randomly chosen each game!\",5,-1,-1,-1);");
	rmSetTriggerPriority(4);
	rmSetTriggerActive(true);
	rmSetTriggerRunImmediately(false);
	rmSetTriggerLoop(false);

	rmSetStatusText("",1.00);
}